import java.util.Vector;

class Function {
	private Vector<Function> funcs;
	private String name;
	private String type;
	private String val1;
	private String val2;
	
	public Function(String name, String type, String val1, String val2, Vector<Function> v) {
		this.name = name;
		this.type = type;
		this.val1 = val1;
		this.val2 = val2;
		funcs = v;
	}
	
	public int calc(int prev) {
		int v1 = -1;
		int v2 = -1;
		
		try {
			v1 = Integer.parseInt(val1);
		} catch(NumberFormatException e) {
			if (val1.equals("prev")) v1 = prev;
			else v1 = iCalc(val1, prev);
		}
		
		try {
			v2 = Integer.parseInt(val2);
		} catch(NumberFormatException e) {
			if (val2.equals("prev")) v2 = prev;
			else v2 = iCalc(val2, prev);
		}
		
		if (type.equals("add")) return v1+v2;
		if (type.equals("sub")) return v1-v2;
		if (type.equals("mult")) return v1*v2;
		if (type.equals("div"))
			if (v2 == 0) return 0;
			else return v1/v2;
		else return 0;
	}
	
	private int iCalc(String name, int prev) {
		Function f = null;
		for (Function g : funcs) if (g.getName().equals(name)) f = g;
		return f.calc(prev);
	}
	
	public String getName() {
		return name;
	}
} 
