/*

	(c) Shopping-ManaJer develoment-team
	This Code is published unter the Gnu-GPL v2

	Modified for JippySnake7
*/

import java.awt.Canvas;
import java.awt.Color;
import javax.swing.JLabel;

class GUIUpdater {
	private Renderer rend;
	private JS8Level l;
	private Snake s;
	//private Player p;
	private int type;
	private boolean drawPaused;
	private int[] playerLevelDone;
	
	//Need to know where to draw new green apples
	private int drawApplesX;
	private int drawApplesY;
	private int curApples;
	
	private int menu;
	//-1: no menu
	//0: mainMenu
	//1: Menu "fresses"
	//.
	//.
	//.
	//6: stats
	private int mmx;
	
	int size = 32;
	int off = -8;
	int fak = 4;
	public GUIUpdater(Canvas c) {
		//player = p;
		drawPaused = false;
		playerLevelDone = new int[100];
		for (int i = 0; i < 100; i++) playerLevelDone[i] = -1;
		rend = new Renderer(c, "graphics/low/graphics.xml");
	}
	
	public void setLevel(JS8Level lv) {
		l = lv;
		prepareHud();
	}
	
	public void prepareHud() {
		//code for preparing hud here
		
		rend.drawRect(0,Color.BLACK, 25*size,0, 5*size,16*size);
		curApples = 0;
		//draw toDo Apples
		drawApplesX = 0;
		drawApplesY = 0;
		for (int i = 0; i < l.getMinApples(); i++) {
			//rend.drawImage(1, 999, 25*size-off+drawApplesX*size, drawApplesY*size-off );
			rend.drawImage(0, 997, 25*size+drawApplesX*4*fak, drawApplesY*4*fak);
			incPos();
		}
		
		drawApplesX = 0;
		drawApplesY = 0;
		
		if (l.timerUsed()) {
			rend.drawRect(0, Color.GREEN, -off, 16*size-off, size*30, 7*fak);
		}
	}
	
	public void setSnake(Snake snk) {
		s = snk;
	}
	
	public synchronized void draw(boolean paused, boolean makeBlind) {
		if (s == null) return;
		if (paused && drawPaused) {
			rend.flushScreen();
			return;
		}
		if (!paused && drawPaused) drawPaused = false;
		
		//Begin new Hud code
		if (s.getLength() > curApples) {
			curApples++;
			rend.drawImage(0, 998, 25*size+drawApplesX*4*fak, drawApplesY*4*fak);
			incPos();
		}
		
		/*
		if (level.timerUsed()) {
			Color col;
			if (level.remainingTime() >= 180)
				col = new Color(510-((int) (level.remainingTime()*17/12)), 255, 0);
			else
				col = new Color(255, (int) (level.remainingTime()*17/12), 0);
			hudRenderer.drawRect(0,Color.BLACK,0,0,4*size,size);
			hudRenderer.drawRect(0,col,0,0,level.remainingTime()*size/(18*5), size);
			hudRenderer.drawTexture(0,903,0,0);
		}
		*/
		//End new Hud code
		
		//renew all snake-layers:
		for (int i = 0; i < 5; i++)
			rend.reNewLayer(2*i+1);
		drawSnake();
		
		//finallay: render everything
		rend.preRender();
		/*
			if (makeBlind) {
			int Y = crd.getY();
			int X = crd.getX();
			int Z = crd.getZ();
			renderer.clearScreen(Color.BLACK, 0, 0,                          20*size, size*Y-4*size-offSize*Z);
			renderer.clearScreen(Color.BLACK, 0, size*Y+5*size-offSize*Z,    20*size, 20*size);
			renderer.clearScreen(Color.BLACK, 0, 0,                          size*X-4*size-offSize*Z, 20*size);
			renderer.clearScreen(Color.BLACK, size*X+5*size-offSize*Z, 0,    20*size, 20*size);
			renderer.drawTextureOnScreen(1100, size*X-4*size-offSize*Z, size*Y-4*size-offSize*Z);
			}
		*/
		
		if (paused) {
		/*
			if (menu == 0) {
				updateMenu(0, level.getType(), 0);
			} else if (menu < 6)
				updateMenu(0, level.getLevelNum()%10, (int) (level.getLevelNum()/10));
			*/
			drawPaused = true;
		}
		showGame();
	}
	
	//draws the level
	public void drawLevel() {
		int X;
		int Y;
		int Z;
		
		rend.reNewAllLayers();
		for (Coord crd : Coord.range(new Coord(0,0,-1), new Coord(24,15,4))) {
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ()+1;
			if (l.getTile(crd) != 1)
				rend.drawImage(Z*2, l.getTile(crd), size*X+Z*off, size*Y+Z*off);
		}
		rend.drawRect(0, Color.BLACK, 0, 16*size, 30*size, 7*fak);
		prepareHud();
	}
	
	private void drawSnake() {
		int X;
		int Y;
		int Z;
		for (Coord crd : Coord.range(Coord.getZeroCoord(), new Coord(24,15,4))) {
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ();
			if (l.isAppleAt(crd)) rend.drawImage(2*Z+1, 999, size*X+off*Z, size*Y+off*Z);
		}
		
		X = s.getHeadPos().getX();
		Y = s.getHeadPos().getY();
		Z = s.getHeadPos().getZ();
		rend.drawImage(2*Z+1, s.getHeadTexture(), size*X+off*Z, size*Y+off*Z);
		
		for (SnakeElement e: s.getBodyElements()) {
			X = e.getPos().getX();
			Y = e.getPos().getY();
			Z = e.getPos().getZ();
			rend.drawImage(2*Z+1, e.getTexture(), size*X+off*Z, size*Y+off*Z);
		}
		
		//draw toDo Apples
		//drawApplesX = 0;
		//drawApplesY = 0;
		//for (int i = 0; i < l.getMinApples(); i++) {
			//rend.drawImage(1, 999, 25*size-off+drawApplesX*size, drawApplesY*size-off );
		//	rend.drawImage(1, 999, 25*size+drawApplesX*size/2, drawApplesY*size/2);
		//	incPos();
		//}

	}
	
	/*
	private void drawStats() {
		int count;
		int drawWidth;
		Color col;
		for (int i = 0; i < 5; i++) {
			count = 0;
			for (int j = 0; j < Globals.NUM_LEVELS[i]; j++) {
				if (player.getLevelDone(i,j) > 1) count++;
				drawWidth = (int) (24.0/5.0*count);
				if (i == 1) drawWidth /= 2;
				if (drawWidth > 120)
					col = new Color(510-((int) (drawWidth*17.0/8.0)), 255, 0);
				else
					col = new Color(255, (int) (drawWidth*17.0/8.0), 0);
				renderer.clearScreen(col, 155*fak, (int) (87.5*fak)+65*fak*i, drawWidth*fak, (int) (62.5*fak));
			}
		}
	}
	*/
	
	/*
	private void drawLC() {
		int t = menu-1;
		int maxY = 5;
		if (t == 1) maxY = 10;
		for (int x = 0; x < 10; x++) {
		for (int y = 0; y < maxY; y++) {
			renderer.drawTextureOnScreen(1200+player.getLevelDone(t,10*y+x), 150*fak+size*x, 150*fak+size*y);
		}
		}
	}
	*/
	
	/*
	public void updateMenu(int p, int x, int y) {
		renderer.preRender();
		Coord crd = snk.getHeadPos();
		if (level.getType()==4) {
			int Y = crd.getY();
			int X = crd.getX();
			int Z = crd.getZ();
			renderer.clearScreen(Color.BLACK, 0, 0,                          20*size, size*Y-4*size-offSize*Z);
			renderer.clearScreen(Color.BLACK, 0, size*Y+5*size-offSize*Z,    20*size, 20*size);
			renderer.clearScreen(Color.BLACK, 0, 0,                          size*X-4*size-offSize*Z, 20*size);
			renderer.clearScreen(Color.BLACK, size*X+5*size-offSize*Z, 0,    20*size, 20*size);
			renderer.drawTextureOnScreen(1100, size*X-4*size-offSize*Z, size*Y-4*size-offSize*Z);
		}

		drawMenu();
		if (menu == 0) {
			if (p == 0) {
				renderer.drawTextureOnScreen(1110+x, (int) (187.5*fak),  (int) (208*fak));
				renderer.drawTextureOnScreen(1110+x, (int) (187.5*fak),  (int) (208*fak));
				renderer.drawTextureOnScreen(1120+(x+1)%5, (int) (337.5*fak),  (int) (208*fak));
				int tmp = (x-1);
				if (tmp < 0) tmp+=5;
				renderer.drawTextureOnScreen(1115+tmp, (int) (37.5*fak),  (int) (208*fak));
				mmx = x;
			}
			
			if (p == 1) {
				renderer.drawTextureOnScreen(1110+mmx, (int) (187.5*fak),  (int) (208*fak));
				if (x == 0) renderer.drawTextureOnScreen(1126, (int) (25.5*fak), (int) (424.5*fak));
				if (x == 1) renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
			}
		} else if (menu < 6) {
			if (p == 0)
				renderer.drawTextureOnScreen(1127,150*fak+size*x,150*fak+size*y);
			if (p == 1)
				renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
		} else if (menu == 6) {
				renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
		}

		showGame();
	}
	*/
	
	public void showGame() {
		rend.flushScreen();
	}
	
/*	public void setMenu(int m) {
		menu = m;
	}
*/
	
	private void incPos() {
		drawApplesX++;
		if (drawApplesX == 10) {
			drawApplesX = 0;
			drawApplesY++;
		}
	}
}