/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
import java.util.TimerTask;
import java.util.LinkedList;

class GameLoop extends TimerTask {
	private JS8Level l;
	private Snake s;
	//private Player player;
	
	private Coord dir;
	private Coord prevDir;
	private Coord nextDir;
	private boolean movedWithNewDir;
	private GUIUpdater updater;
	
	private boolean paused;
	private boolean drawPaused;
	
	private boolean goDown;
	private boolean appleEaten;
	private boolean levelDone;
	private int textGr;
	private int subGr;
	private int textDir;
	private int apples;
	private int moveDown;
	
	private Coord zero;
	private Coord headPos;
	private Coord prevHeadPos;
	private Coord nextBodyPos;
	private Coord prevBodyPos;
	private LinkedList<Coord> newDirs;
	
	//private SoundPlayer soundPlayer;
	
	private int runs;
	
	public GameLoop(GUIUpdater u) {
		l = new JS8Level("levels/test.xml");
		s = new Snake(l.getStartPos());
		updater = u;
		updater.setLevel(l);
		updater.setSnake(s);
		updater.drawLevel();
		//player = p;
		dir = Coord.getZeroCoord();
		zero = Coord.getZeroCoord();
		paused = false;
		moveDown = 4;
		prevHeadPos = null;
		nextDir = null;
		prevDir = null;
		movedWithNewDir = true;
		goDown = false;
		appleEaten = false;
		apples = 0;
		newDirs = new LinkedList<Coord>();
		//soundPlayer = new SoundPlayer(true);
		
		levelDone = false;
		runs = 0;
	}
	
	public void run() {
		//Remove snake mark
		if (!appleEaten)
			l.setSnake(s.getBodyPos(), false);
		appleEaten = false;
		
		//Get previos head pos after moving
		prevHeadPos = s.getHeadPos();
		
		//Move snake
		s.move(dir);
		
		//set Snake mark
		if (apples > 0)
			l.setSnake(prevHeadPos, true);
		
		//Get headPos
		headPos = s.getHeadPos();
		
		//Move it one down, if needed and update headPos
		if ((moveDown < 4)) {
			if  (( (moveDown+2)%4 == getDirNum(dir) )) {
			s.setHeadPos(headPos.add(new Coord(0,0,-1)));
			headPos = s.getHeadPos();
			}
		}
		moveDown = 4;
		
		//Behaviour on level
		int tile = l.getTile(headPos)%6;
		int pTile = l.getTile(prevHeadPos.add(new Coord(0,0,-1)))%6;
		if (tile == 0) {
			die();
			return;
		} else if (pTile > 1) {
			if ((pTile == 2) && (dir.scaleProd(new Coord(1,0))) == 0) {
				die();
				return;
			}
			if ((pTile == 3) && (dir.scaleProd(new Coord(0,1))) == 0) {
				die();
				return;
			}
			if ((pTile == 4) && (dir.scaleProd(new Coord(1,0))) == 0) {
				die();
				return;
			}
			if ((pTile == 5) && (dir.scaleProd(new Coord(0,1))) == 0) {
				die();
				return;
			}

		} else if (tile == 2) /* on Ramp-Right */ {
			if (dir.isRightOf(zero)) moveUp();
			else {
				die();
				return;
			}
		} else if (tile == 3) /* on Ramp-Down */ {
			if (dir.isDownOf(zero)) moveUp();
			else {
				die();
				return;
			}
		} else if (tile == 4) /* on Ramp-Left */ {
			if (dir.isLeftOf(zero)) moveUp();
			else {
				die();
				return;
			}
		} else if (tile == 5) /* on Ramp-Up */ {
			if (dir.isUpOf(zero)) moveUp();
			else {
				die();
				return;
			}
		}
		
		tile = l.getTile(headPos.add(new Coord(0,0,-1)))%6;
		if (tile == 2) {
			if (dir.scaleProd(new Coord(1,0)) == 0) {
				if (l.getTile(prevHeadPos.add(new Coord(0,0,-1)))%6 != 2) {
					die();
					return;
				}
			} else {
				moveDown = 0;
			}
		} else if (tile == 3) {
			if (dir.scaleProd(new Coord(0,1)) == 0) {
				if (l.getTile(prevHeadPos.add(new Coord(0,0,-1)))%6 != 3) {
					die();
					return;
				}
			} else moveDown = 1;
		} else if (tile == 4) {
			if (dir.scaleProd(new Coord(-1,0)) == 0) {
				if (l.getTile(prevHeadPos.add(new Coord(0,0,-1)))%6 != 4) {
					die();
					return;
				}
			} else moveDown = 2;
		} else if (tile == 5) {
			if (dir.scaleProd(new Coord(0,-1)) == 0) {
				if (l.getTile(prevHeadPos.add(new Coord(0,0,-1)))%6 != 5) {
					die();
					return;
				}
			} else moveDown = 3;
		}
		
		//retexture Snake
			//Snake head
		textGr = getTextureGroup(headPos);
		textDir = getDirNum(dir);
		subGr = 0;
		s.setHeadTexture(20*textGr+4*subGr+textDir+1000);
		
			//Snake end
		if (apples > 0) {
			textGr = getTextureGroup(s.getBodyPos());
			subGr = 4;
			if (apples > 1)
				textDir = getDirNum(s.getNextBodyPos().sub(s.getBodyPos()));
			else if (apples == 1)
				textDir = getDirNum(s.getHeadPos().sub(s.getBodyPos()));
			s.setBodyTexture(20*textGr+4*subGr+textDir+1000);
		}
		
			//Body
		if (apples > 1) {
			textGr = getTextureGroup(prevHeadPos);
			prevBodyPos = s.getPrevPrevBodyPos();
			Coord diff1 = headPos.sub(prevHeadPos);
			Coord diff2 = prevHeadPos.sub(prevBodyPos);
			/*if (diff1.equals(diff2)) */ subGr = 2;
			if ((diff1.getX() == diff2.getY()) && (diff1.getY() == -1*diff2.getX())) subGr = 1;
			if ((diff1.getX() == -1*diff2.getY()) && (diff1.getY() == diff2.getX())) subGr = 3;
			textDir = getDirNum(diff1);
			s.setPrevBodyTexture(20*textGr+4*subGr+textDir+1000);
		}
		
		//Check for an apple
		if (l.isAppleAt(headPos)) {
			//soundPlayer.playSound(soundPlayer.appleSound);
			l.removeApple(headPos);
			appleEaten = true;
			s.grow(headPos);
			apples++;
		}
		
		//Get the direction for the next move
		if (!newDirs.isEmpty()) {
			//soundPlayer.playSound(soundPlayer.turnSound);
			dir = newDirs.remove();
		} else {
			movedWithNewDir = true;
		}
		
		//Snake is moved and restextured, now lets draw the scene
		updater.draw(paused, false);
		runs++;
	}
	
	private void moveUp() {
		s.setHeadPos(headPos.add(new Coord(0,0,1)));
		headPos = s.getHeadPos();
	}
	
	//Get the needed Texturegroup for an element that is on Position c
	private int getTextureGroup(Coord c) {
		int tg = l.getTile(c.add(new Coord(0,0,-1)))%6;
		if (tg > 0) tg--;
		return tg;
	}
	
	//Calculates the DirectionNumber from given coordinate
	// 0 means right
	// 1 meand down
	// 2 mean left
	// 3 mean up
	private int getDirNum(Coord c) {
		if ((c.getX() == 1) && (c.getY() == 0)) return 0;
		if ((c.getX() == 0) && (c.getY() == 1)) return 1;
		if ((c.getX() == -1) && (c.getY() == 0)) return 2;
		if ((c.getX() == 0) && (c.getY() == -1)) return 3;
		return 0;
	}

	//If snake dies, to all the needed things here
	private void die() {
		dir = Coord.getZeroCoord();
		s.clear();
		l.init("levels/test.xml");
		s.setHeadPos(l.getStartPos());
		updater.prepareHud();
		updater.draw(paused, false);
		runs = 0;
		apples=0;
	}
	
	//Interface to set the next moving directions
	public void setDir(Coord newDir) {
		if (movedWithNewDir) {
			if ((newDir.getX() == -1*dir.getX()) && (newDir.getY() == -1*dir.getY())) return;
			//soundPlayer.playSound(soundPlayer.turnSound);
			dir = newDir;
			movedWithNewDir = false;	
		} else {
			if (newDirs.isEmpty()) {
				if ((newDir.getX() == -1*dir.getX()) && (newDir.getY() == -1*dir.getY())) return;
				newDirs.addLast(newDir);
			} else {
				Coord lastDir;
				lastDir = newDirs.getLast();
				if ((newDir.getX() == -1*lastDir.getX()) && (newDir.getY() == -1*lastDir.getY())) return;
				if (newDirs.size() > 1) return;
				newDirs.addLast(newDir);
			}
			//nextDir = newDir;
		}
	}
	
	//Interface to pause/resume the game
	public void setPaused(boolean paused) {
		this.paused = paused;
	}
	
	//Interface to chack if game is paused
	public boolean getPaused() {
		return paused;
	}
}